--  
game = {
	name = "", -- 
	genre = "", --
	author = "", --
	year = "", -- (, , )
	description = "" --
}
--  .   Delphi.  :    bass (   bass.close)
--[[arguments = {}
commandline:gsub('"([^"]*)"', function (arg)
	table.insert(arguments, (arg:gsub('\\', '/')))
	return ""
end)]]

math.randomseed(os.time())
milena = {}
milena.msg = showmsg
milena.lpart = '<body>'
milena.rpart = '</body>'
milena.menu_on = true
milena.on_timer = {}
milena.TIMER = timer
milena.TIMER.timers = {}
milena.TIMER.create_std = milena.TIMER.create
milena.TIMER.create = function (delay)
	local id = milena.TIMER.make_id()
	milena.TIMER.timers[id] = delay
	return milena.TIMER.create_std(delay, id)
end
function GetTimerDelay(id)
	return milena.TIMER.timers[id]
end
milena.TIMER.last_id = 1000
milena.TIMER.make_id = function ()
	milena.TIMER.last_id = milena.TIMER.last_id+1
	return milena.TIMER.last_id
end
milena.FILE = file

--------------------------------------------
--      --
--------------------------------------------

fs = {}
fs.opendlg = milena.FILE.open
fs.savedlg = milena.FILE.save
fs.chdir = milena.FILE.set_dir
fs.currentdir = milena.FILE.get_dir
fs.mkdir = milena.FILE.create_dir

fclock = {}
fclock.createtimer = milena.TIMER.create
fclock.killtimer = milena.TIMER.kill

--------------------------------------------
--------------------------------------------
--------------------------------------------

file = nil
timer = nil
milena.menu = {{command = "milena._PRINTTEXT('') milena.in_menu = false", name="  "}, {name="<hr color=%s width=%s>"}}
milena.in_menu = false
milena.exit = {function () milena.TIMER.kill(milena.timer) end}
milena.outprint = true
milena.links = {}
milena.uselinks = true
milena.buffer = ""
milena.pause = {lastkey = 0}
milena.on_pause = function () end
milena.kind = 'lite'
package.path = '.\\?.mmod;.\\modules\\?.mmod;'..milena.FILE.get_dir():gsub('\\', '/')..'/modules/?.mmod;'..package.path
package.cpath = package.cpath..";./?.dll;./?.so;../lib/?.so;../lib/vc_dll/?.dll;../lib/bcc_dll/?.dll;../lib/mingw_dll/?.dll;"..milena.FILE.get_dir():gsub('\\', '/')..'/?.dll;'..milena.FILE.get_dir():gsub('\\', '/')..'/libs/?.ml;'
----------
----
----------
require "bass"

text = {blockstart = "", blockend = "", css = "", color = "#000000", bgcolor = "#FFFFFF", font = '"Trebuchet MS" Arial, Helvetica, sans-serif', size = 7, bgimage = "", bgrepeat="repeat", style = " ", leftmargin = 3, topmargin = 3, advanced = ""}
button = {color = '#0000FF', bgcolor = 'none', size= 7, style = ' ', font = '"Trebuchet MS" Arial, Helvetica, sans-serif', selcolor = "#FF0000", bgselcolor="none", advanced = "", seladvanced = ""}
game_dir = 'scripts'
local md5f = package.loadlib('libs/md5.ml','luaopen_md5')
if md5f~= nil then md5f() end
function OnDestroy()
	for i=1, #milena.exit do
		(milena.exit[i] or function () end)()
	end
	for k, v in pairs(milena.TIMER.timers) do
		milena.TIMER.kill(k)
	end
	milena.TIMER.timers = {}
	milena.exit = {}
end
function OnKeyboard(a, b)
		if a==27 and not milena.pause.used then
			if milena.menu_on then
				if milena.in_menu then
					milena.clrscr()
					--milena.print_std(milena.GetStyle()..milena.lpart..(text.blockstart or "")..milena.buffer..milena.rpart..(text.blockend or ""))
					milena._PRINTTEXT("")
					window.set_scrollpos(milena.scrollpos.x, milena.scrollpos.y)
					milena.in_menu = false
				else
					milena.print_menu()
				end
			end
		else
			milena.lastkey = a
			previous_key = a
			milena.key_press = true
			proc(key_pressed)
		end
end
milena.update = function () end
function milena._PRINTTEXT(buff, menu)
	if not menu then
		milena.print_std(milena.GetStyle()..milena.lpart..(text.blockstart or "")..milena.buffer..buff..(text.blockend or "")..milena.rpart)
	else
		milena.print_std(milena.GetStyle()..milena.lpart..(text.blockmenustart or text.blockstart or "")..milena.buffer..buff..(text.blockmenuend or text.blockend or "")..milena.rpart)
	end
end
function milena.print_menu()
	local buff = ""
	local a, b = GetStyle(button)
	milena.clrscr()
	milena.in_menu = true
	milena.scrollpos = {}
	milena.scrollpos.x, milena.scrollpos.y = window.get_scrollpos()
	local milena_dir = get_dir(arguments[1]):gsub("\\", "/")
	buff = buff..('<div style="position:fixed;left:0;top:0;width:100%;height:100%;background-color:rgba('..milena.invert(text.bgcolor)..',0.25); vertical-align: middle;"><center><table align=center width=20% style="border: 4px solid '..button.color..';padding:1%;background-color:rgb('..milena.rgb(text.bgcolor)..');border-radius: 5%;background-image:url('..(text.bgimage or "")..')"><tr><td>')
	buff = buff..('<center><br>'..'<font size='..(text.size*3)..'></font>'..'<br>')
		for i=1, #milena.menu do
			if milena.menu[i].command then
				buff = buff..('<a class="button" href="action://milena.clrscr() milena.in_menu = false '..milena.menu[i].command..' window.set_scrollpos(milena.scrollpos.x, milena.scrollpos.y)">'..a..milena.menu[i].name..b..'</a><br>')
			else
				buff = buff..milena.menu[i].name:format('rgba('..milena.rgb(button.color)..',0.5)', '100%')
			end
		end
	buff = buff..('<a class="button" href="action://window.close()">'..a..''..b..'</a><br>')
	buff = buff..('</center><br>')
	buff = buff..('</td></tr></table></center></div>')
	milena._PRINTTEXT(buff, true)
	window.set_scrollpos(milena.scrollpos.x, milena.scrollpos.y)
end
function milena.invert(c, rt)
	if not rt then rt=0 end
	c = c:sub(2, -1)
	n = n or 10
	local r, g, b
	r = math.abs(milena.hex2dec(c:sub(1, -5)) - 255)
	g = math.abs(milena.hex2dec(c:sub(3, -3)) - 255)
	b = math.abs(milena.hex2dec(c:sub(5, -1)) - 255)
	if rt==1 then
		return '#'..milena.dec2hex(r)..milena.dec2hex(g)..milena.dec2hex(b)
	else
		return r..','..g..','..b
	end
end
function milena.rgb(c, rt)
	if not rt then rt=0 end
	c = c:sub(2, -1)
	n = n or 10
	local r, g, b
	r = milena.hex2dec(c:sub(1, -5))
	g = milena.hex2dec(c:sub(3, -3))
	b = milena.hex2dec(c:sub(5, -1))
	if rt==1 then
		return '#'..milena.dec2hex(r)..milena.dec2hex(g)..milena.dec2hex(b)
	else
		return r..','..g..','..b
	end
end
function milena.darker(c, n)
	c = c:sub(2, -1)
	n = n or 10
	local r, g, b
	r = milena.dec2hex((milena.hex2dec(c:sub(1, -5)) - n))
	g = milena.dec2hex((milena.hex2dec(c:sub(3, -3)) - n))
	b = milena.dec2hex((milena.hex2dec(c:sub(5, -1)) - n))
	return '#'..r..g..b
end
function milena.dec2hex(n)
	if n~=nil and n>=0 then
		local t = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'}
		if n<=15 then return t[n+1] end
		return milena.dec2hex(math.floor(n/16))..milena.dec2hex(n-(math.floor(n/16)*16))
	else
		return "00"
	end
end
function milena.hex2dec(n)
	local ret = 0
	n = n:reverse()
	if n~=nil then
		local t = {['0']=0,['1']=1,['2']=2,['3']=3,['4']=4,['5']=5,['6']=6,['7']=7,['8']=8,['9']=9,['A']=10,['B']=11,['C']=12,['D']=13,['E']=14,['F']=15}
		for i=1, #n do
			ret = ret+(t[chr(n, i):upper()]*(16^(i-1)))
		end
	end
	return ret
end
function milena.tohtml(s) return s end
milena.outtext = ""
function milena.getchar(n) return "0" end
function chr(s,i)
	return string.char(s:byte(i))
end
function GetStyle(from)
	local s1, s2='',''
	local underl = false
	for i=1, #from.style do
		if chr(from.style, i)=='I' then s1 = s1..'<I>' s2 = '</I>'..s2 end
		if chr(from.style, i)=='U' then s1 = s1..'<U>' s2 = '</U>'..s2 underl = true end
		if chr(from.style, i)=='B' then s1 = s1..'<B>' s2 = '</B>'..s2 end
		if chr(from.style, i)=='S' then s1 = s1..'<S>' s2 = '</S>'..s2 end
	end
	return s1, s2
end
function milena.GetDlgStyle()
		return [[<style>
		]]..(milena.style or "")..[[
		html, input
		{
		background-color: ]]..(text.bgcolor or "white")..[[;
		color:]]..(text.color or "black")..[[;
		font-family: "]]..(text.font or "Arial")..[[";
		line-height: 120%;
		]]..(text.html or "")..[[
		}
		input
		{
			background-image: none;
			background-color: ]]..(text.bgcolor or "white")..[[;
			border: 1px solid ]]..(button.color or black)..[[;
			font-size: ]]..math.ceil((text.size or "Arial")*2.25)..[[;
			border-radius: 10px;
		}
		body
		{
		border: 4px solid ]]..(button.color or black)..[[;
		//border-radius: 15px;
		margin: 0;
		border-radius: 10px;
		font-size: ]]..math.ceil((text.size or "Arial")*2.25)..[[;
		background-image: url(]]..(text.bgimage or "")..[[);
		background-repeat: ]]..(text.bgrepeat or "no-repeat")..[[;
		background-color:]]..(text.bgcolor or "white")..[[;
		}
		a.button
		{
		text-decoration: none;
		font-family: "]]..(button.font or "Arial")..[[";
		font-size: ]]..math.ceil((button.size or 7)*2.25)..[[;
		padding: -1px;
		]]..(button.advanced or "")..[[
		}
		a.button:link, a.button:active
		{
		color:]]..(button.color or "black")..[[;
		background-color:]]..(button.bgcolor or "white")..[[;
		}
		a.button:hover
		{
		color:]]..(button.selcolor or "black")..[[;
		background-color:]]..(button.bgselcolor or "silver")..[[;
		]]..(button.seladvanced or "")..[[
		}
		</style>]]
end
function milena.GetStyle()
	if (text.css or "")=="" or text.css=="none" then
		return [[<style>
		]]..(milena.style or "")..[[
		*[fade-in]
		{
		opacity: 0;
		assigned!: self::opacity = 0, self.start-timer(50);
		timer!: self::opacity < 1.0?
		self::opacity = self::opacity + 0.1 # return cancel;
		}
		*[fade-out]
		{
		opacity: 1;
		assigned!: self::opacity = 1.0, self.start-timer(50);
		timer!: self::opacity > 0?
		self::opacity = self::opacity - 0.1 # return cancel;
		}
		html
		{
		color:]]..(text.color or "black")..[[;
		font-family: "]]..(text.font or "Arial")..[[";
		line-height: 120%;
		]]..(text.html or "")..[[
		}
		body
		{
		margin: 0;
		padding-left: ]]..(text.leftmargin or 16)..[[;
		padding-top: ]]..(text.topmargin or 16)..[[;
		padding-right: ]]..(text.leftmargin or 16)..[[;
		padding-bottom: ]]..(text.topmargin or 16)..[[;
		font-size: ]]..math.ceil((text.size or "Arial")*2.25)..[[;
		background-image: url(]]..(text.bgimage or "")..[[);
		background-repeat: ]]..(text.bgrepeat or "no-repeat")..[[;
		background-color:]]..(text.bgcolor or "white")..[[;
		overflow: auto;
		]]..(text.advanced or "")..[[
		}
		a.button
		{
		text-decoration: none;
		font-family: "]]..(button.font or "Arial")..[[";
		font-size: ]]..math.ceil((button.size or 7)*2.25)..[[;
		padding: -1px;
		]]..(button.advanced or "")..[[
		}
		a.button:link, a.button:active
		{
		color:]]..(button.color or "black")..[[;
		background-color:]]..(button.bgcolor or "white")..[[;
		}
		a.button:hover
		{
		color:]]..(button.selcolor or "black")..[[;
		background-color:]]..(button.bgselcolor or "silver")..[[;
		]]..(button.seladvanced or "")..[[
		}
		</style>]]
	else
		local css = io.open(text.css, "r")
		local style = css:read("*a")
		css:close()
		return '<style>'..style..'</style>'
	end
end
function milena.gen_name(n)
	local result = '_'
	if milena.normallocnames then
		n = n:gsub('[%s%%&%^%*%+%-%[%]%{%}%|%\\%/%?%.%,%:%4%$%#%%@%"%\']', '_')
		return result..n
	end
	for i=1,#n do
		result=result..n:byte(i)
	end
	return result
end
milena.BehaviorEvents = {
[0] = "BUTTON_CLICK",
[1] = "BUTTON_PRESS",
[2] = "BUTTON_STATE_CHANGED",
[3] = "EDIT_VALUE_CHANGING",
[4] = "EDIT_VALUE_CHANGED",
[5] = "SELECT_SELECTION_CHANGED",
[6] = "SELECT_STATE_CHANGED",
[7] = "POPUP_REQUEST",
[8] = "POPUP_READY",
[9] = "POPUP_DISMISSED",
[10] = "MENU_ITEM_ACTIVE",
[11] = "MENU_ITEM_CLICK",

[16] = "CONTEXT_MENU_REQUEST",
[17] = "VISIUAL_STATUS_CHANGED",

[128] = "HYPERLINK_CLICK",
[129] = "TABLE_HEADER_CLICK",
[130] = "TABLE_ROW_CLICK",
[131] = "TABLE_ROW_DBL_CLICK",

[144] = "ELEMENT_COLLAPSED",
[145] = "ELEMENT_EXPANDED",
[146] = "ACTIVATE_CHILD",

[256] = "FIRST_APPLICATION_EVENT_CODE",

[384] = "KEY_DOWN",
[385] = "KEY_UP",
[386] = "KEY_CHAR",

[512] = "FOCUS_LOST",
[513] = "FOCUS_GOT",

[1024] = "MOUSE_ENTER",
[1025] = "MOUSE_LEAVE",
[1026] = "MOUSE_MOVE",
[1027] = "MOUSE_UP",
[1028] = "MOUSE_DOWN",
[1029] = "MOUSE_DCLICK",
[1030] = "MOUSE_WHEEL",
[1031] = "MOUSE_TICK",
[1032] = "MOUSE_IDLE",

[1033] = "DROP",
[1034] = "DRAG_ENTER",
[1035] = "DRAG_LEAVE",

[2048] = "HANDLE_UNKNOWN"
}
function OnBehaviorEvent(event_type, attr, target)
	local et = event_type
	if type(event_type)~='string' then event_type = milena.BehaviorEvents[event_type] or "UNKNOWN" end
	proc(behavior_loc, event_type, attr, target, et)
	if event_type=='HYPERLINK_CLICK'  then
		OnLinkClicked(attr.href or "")
	elseif event_type=='KEY_DOWN' then
		OnKeyboard(attr.key_code, 0)
	end
end
function OnElementEnum(attr)
	if attr.class then
		
	end
end
function OnLinkClicked(s)
	if (s:find('action://'))~=1 then
	if rawget(_G, milena.gen_name(':'..s)) then
		cls()
		goto(s)
	end
	else
		assert(loadstring(s:sub(#'action://'+1, -1)))()
	end
end
function OnTimer(id)
	--     .    
	if (not milena.in_menu and (milena.last_buffer or '\0')~=milena.buffer) then
		--milena.print_std(milena.GetStyle()..milena.lpart..(text.blockstart or "")..milena.buffer..(text.blockend or "")..milena.rpart)
		milena._PRINTTEXT("")
		milena.last_buffer = milena.buffer
	end
	if id==milena.timer and not milena.in_menu then
		proc(timer_loc)
	else
		milena.on_pause(id)
	end
	for i=1, #milena.on_timer do
		(milena.on_timer[i] or function (id) end)(id)
	end
end
function get_ext(filePath)
	for i=#filePath, 1, -1 do
		if chr(filePath, i)=='.' then
			return filePath:sub(i, -1)
		end
	end
	return ""
end
function trim(s)
	local i = 1
	local waschar = false
	local ret = ""
	while i<=#s do
		if s:byte(i)>=33 then waschar = true end
		if waschar then ret=ret..chr(s, i) end
		i = i+1
	end
	s = ret
	i = #ret
	ret = ""
	waschar = false
	while i>=1 do
		if s:byte(i)>=33 then waschar = true end
		if waschar then ret = chr(s,i)..ret end
		i = i-1
	end
	return ret
end
function load_msf(fn)
	local f = nil
	local fname = os.tmpname()
	if get_ext(fn)~='.pua' and get_ext(fn)~='.msf' and get_ext(fn)~='.msz' then
		if get_ext(fn)=='.pca' or get_ext(fn)=='.mcf' then
			local f0 = io.open(fn, 'rb')
			local f1 = io.open(fname, 'wb')
			f1:write(md5.decrypt(f0:read('*a'), md5.crypt('password', 'password', 1), 1))
			f0:close()
			f1:close()
			f = io.open(fname,'r')
		end
	elseif get_ext(fn)=='.msz' then
		--milena.open_msz(fn)
		return false
	else
		f = io.open(fn, 'r')
	end
	milena.files[#milena.files+1] = {}
	milena.files[#milena.files].name = fn
	milena.files[#milena.files].index = {}
	milena.files[#milena.files].lines = {}
	f = io.open(fn, 'r')
	for l in f:lines() do
		milena.files[#milena.files].lines[#milena.files[#milena.files].lines+1]=l
	end
	f:close()
	if get_ext(fn)=='.pca' or get_ext(fn)=='.mcf' then
		os.remove(fname)
	end
	for i = 1, #milena.files[#milena.files].lines do
		local l = milena.files[#milena.files].lines[i]
		if string.char(string.byte(l, 1)) == ':' then
			milena.files[#milena.files].index[l] = {}
			milena.files[#milena.files].index[l].room = ''
			for j = i+1, #milena.files[#milena.files].lines do
				if milena.files[#milena.files].lines[j]~='endl' then
					if string.char(string.byte(milena.files[#milena.files].lines[j],1))~=':' then
						milena.files[#milena.files].index[l].room=milena.files[#milena.files].index[l].room..milena.files[#milena.files].lines[j]..'\n'
					end
				else
					assert(loadstring('function '..milena.gen_name(l)..'(...)\nwhile true do\nif true then\n'..milena.files[#milena.files].index[l].room..'\nend\nbreak\nend\nend'), "    \""..l:sub(2).."\"")()
					break
				end
			end
		end
	end
	return 1
end
function open_msf(str)
	package.path='.\\?.mmod;'..package.path
	timer_loc = "timerloc"
	before_loc = "common"
	after_loc = 'common1'
	input_loc = 'inputloc'
	key_pressed = 'keypressed'
	behavior_loc = 'behaviorloc'
	inputtext = ''
	milena.files = {}
	local loaded = load_msf(str)
	cls()
	if loaded then
		for i=1,#milena.files do
			if milena.files[i].name==str then
				local room=''
				for j=1, #milena.files[i].lines do
					if milena.files[i].lines[j]~='endl' then
						if string.char(string.byte(milena.files[i].lines[j],1))~=':' then
							room = room..milena.files[i].lines[j]..'\n'
						else
							current_loc = milena.files[i].lines[j]:sub(2) or ''
						end
					else
						break
					end
				end
				assert(loadstring('return function (...) while true do\nif true then\n'..room..'\nend\nbreak\nend\nend'), '    "'..(current_loc or '')..'"')()()
				break
			end
		end
	end
end
function extract_tag(n, m)
	local tag = {}
	for i=1, #m do
		n = n:gsub('%<[%/]*'..m[i]..'[^%>]*%>', function (a)
			table.insert(tag, a)
			return ''
		end)
	end
	return n, tag
end

require "extend.commands"
--require "extend.msz"
-- 
require "extend.config"
--require "extend.installer"

--_INSTALL_GAME()