--\brief        
--\param[in] loc \b ,  ,    
--\param[in] name \b ,  
function btn(loc, name)
	local a, b = GetStyle(button)
	local b_, tag_ = extract_tag(name, {'center', 'div', 'h[1-9]'})
	for i=1, #tag_ do
		if tag_[i]:find('^%<[^%/]') then
			p(tag_[i])
		end
	end
	p('<a class="button" href=\''..loc..'\'>'..a..b_..b..'</a>')
	for i=#tag_, 1, -1 do
		if tag_[i]:find('^%<%/') then
			p(tag_[i])
		end
	end
end
milena.print_std = p
function print(s)
	local a, b = GetStyle(text)
	local function put_tags(result, ts, te)
		result = result:gsub('(%b><)', function (a)
			a = put_tags(a:sub(2, -2), ts, te)
			return '>'..ts..a..te..'<'
		end)
		return result
	end
	s = put_tags(s, a, b)
	if not s:find('^%s<') then
		s = a..s..b
	end
	milena.buffer = milena.buffer..s
end
function milena.printout()

end
milena.print = print
--\brief  ,   ,    text,      
--\param[in] ... \b , ,   
function pstd(...)
	for i = 1, #arg do
		milena.buffer = milena.buffer..tostring(arg[i])
	end
end
--\brief  ,   ,    text,      
--\param[in] ... \b , ,   
function pstdl(...)
	for i = 1, #arg do
		milena.buffer = milena.buffer..tostring(arg[i])
	end
	ps '<br>'
end
--\brief        
--\param[in] ... \b , ,   
function p(...)
	for i = 1, #arg do
		milena.print(tostring(arg[i]):gsub('\n', '<br>'))
	end
end
--\brief        
--\param[in] ... \b , ,   
function pln(...)
	p(...)
	p '<br>'
end
--\brief        
--\param[in] loc \b ,  ,    
--\param[in] name \b ,  
function btnl(loc, name)
	btn(loc, name)
	p '<br>'
end
--\brief        
--\param[in] loc \b , ,     
--\param[in] name \b ,  
function act(loc, name)
	local a, b = GetStyle(button)
	local b_, tag_ = extract_tag(name, {'center', 'div'})
	for i=1, #tag_ do
		if tag_[i]:find('^%<[^%/]') then
			p(tag_[i])
		end
	end
	p('<a class="button" href=\'action://cls()'..loc..'\'>'..a..b_..b..'</a>')
	for i=#tag_, 1, -1 do
		if tag_[i]:find('^%<%/') then
			p(tag_[i])
		end
	end
end
--\brief        
--\param[in] loc \b , ,     
--\param[in] name \b ,  
function actl(loc, name)
	act(loc, name)
	p '<br>'
end
--\brief       
--\param[in] fn \b ,  ,   
function include(fn)
	load_msf(fn)
end
--\brief   
--\param[in] n \b   ,  ,   ,      (     -  ,       );  ,  "anykey" -    ,  "stop"  
--\param[in] loc \b ,  ,         
--\param[in] ... \b  , ,    ,      
function pause(n, loc, ...)
	if n=='anykey' and not loc then return end
	if n=='stop' then milena.TIMER.kill(milena.pause.timer or 0) return end
	if not loc then
		sleep(n)
	elseif n~='anykey' then
		milena.pause.used = true
		milena.pause.goto = loc
		milena.pause.properties = {...}
		milena.TIMER.kill(milena.pause.timer or 0)
		milena.pause.timer = milena.TIMER.create(n)
		milena.on_pause = function (id)
			if id==milena.pause.timer then
				milena.TIMER.kill(id)
				milena.pause.used = false
				proc(milena.pause.goto, unpack(milena.pause.properties))
			end
		end
	else
		milena.pause.used = true
		milena.pause.goto = loc
		milena.pause.properties = {...}
		milena.TIMER.kill(milena.pause.timer or 0)
		milena.pause.timer = milena.TIMER.create(100)
		milena.key_press = false
		milena.on_pause = function (id)
			if id==milena.pause.timer then
				if milena.key_press then
					milena.key_press = false
					milena.TIMER.kill(milena.pause.timer)
					milena.pause.used = false
					proc(milena.pause.goto, unpack(milena.pause.properties))
					return
				end
			end
		end
	end
end
--\brief   
--\param[in] a \b ,   ,    
--\param[in] b \b ,   
function rnd(a, b)
	if b~=nil and a<b then
		return math.random(a,b)
	elseif a~=nil and a~=0 then
		return math.random(a)
	else
		return math.random()
	end
end
--\brief       name,   ,      name
--\param[in] name \b ,  
--\param[in] func \b ,      
function location(name, func)
	if func==nil or type(func)~='function' then
		local f=milena.gen_name(':'..name)
		return _G[f]
	else
		_G[milena.gen_name(':'..name)]=func
		return func
	end
end
--\brief      n
--\param[in] n \b ,  
function get(n)
	return _G[n]
end
--\brief      n  v
--\param[in] n \b ,  
--\param[in] v \b  ,  
function set(n, v)
	_G[n] = v
end
--   
function execstring(s)
	assert(loadstring(s))()
end
--\brief      n
--\param[in] n \b ,  
--\param[in] ... \b  , ,  
function proc(n, ...)
	if type(n)=='string' then
		return (rawget(_G, milena.gen_name(':'..n)) or function () end)(...)
	end
end
--\brief      n,     
--\param[in] n \b ,  
--\param[in] ... \b  , ,  
function goto(n, ...)
	previous_loc = current_loc or ''
	current_loc = n
	proc(before_loc)
	proc(current_loc, ...)
	proc(after_loc)
end
--   
function contact(...)
	local ret=''
	for i=1,#arg do
		ret=ret..arg[i]
	end
	return ret
end
--\brief  ,    
--\param[in] str \b , ,    
function lowercase(str)
		local out__=''
		for i=1,#str do
				if (str:byte(i)>=(''):byte() and str:byte(i)<=(''):byte())or(str:byte(i)>=('A'):byte() and str:byte(i)<=('Z'):byte()) then
					out__=out__..string.char(str:byte(i)+32)
				else
					out__=out__..chr(str,i)
				end
		end
		return out__:lower()
end
lowercaseR = lowercase
--\brief  ,    
--\param[in] str \b , ,    
function uppercase(str)
		local out__=''
		for i=1,#str do
				if (str:byte(i)>=(''):byte() and str:byte(i)<=(''):byte())or(str:byte(i)>=('A'):byte() and str:byte(i)<=('Z'):byte()) then
					out__=out__..string.char(str:byte(i)-32)
				else
					out__=out__..chr(str,i)
				end
		end
		return out__:upper()
end
uppercaseR = uppercase
function fileexists(fn)
	local f = io.open(fn, 'r')
	if not f then return false else f:close() return true end
end
milena.clear = cls
milena.clrscr = function()
end
--\brief   
function cls()
	--   
	milena.elements = {}
	milena.buffer = ""
	milena.last_buffer = nil
	milena.table_buffer = {}
end

function input(a, b, c)
	--  
	local an, bn = GetStyle(button)
	local at, bt = GetStyle(text)
	window.msg_def_text(c or "")
	return milena.msg(milena.GetDlgStyle()..'<center>'..at..(a or "")..bt..'</center><br><center><input name = "INPUT" value="'..(c or "")..'" ffocus=false style="width:90%;assigned!: self.ffocus==false?self:focus = true, self.setSelection(self:value.length,self:value.length), self.ffocus=true;"/></center><br><center><a href="" class="button" name="CANCEL">'..an..''..bn..'</a>&nbsp;<a class="button" href="" name="OK">'..an..''..bn..'</a></center>', (b or ""), 320, 320, false)
end
function message(...)
	local an, bn = GetStyle(button)
	a = ''
	for i=1, #arg do
		a = a..tostring(arg[i])..'\t'
	end
	milena.msg(milena.GetDlgStyle()..'<center>'..a..'<br><br><a class="button" href="" name="OK">'..an..'Ok'..bn..'</a></center>', '  2', 320, 320, false)
end
panicmessage = message

milena.input = input
--   
--\brief    
--\param[in] a \b ,   
--\param[in] b \b ,   
--\param[in] c \b ,   
--\function input(a, b, c)
input = setmetatable({focus = function () end, show = function () end}, {
__call = function (t, ...)
	local str = milena.input(...)
	rawset(t, 'text', str)
	proc(input_loc)
	return str
end})
milena.FILE.set_dir(game_dir)
game_dir = milena.FILE.get_dir()
function start()
end
function stop()
end
function get_dir(s)
	if not s then return s end
	for i=#s, 1, -1 do
		if chr(s, i)=='\\' or chr(s, i)=='/' then
			return s:sub(1, i)
		end
	end
	return s
end
function get_file(s)
	for i=#s, 1, -1 do
		if chr(s, i)=='\\' or chr(s, i)=='/'  then
			return s:sub(i+1, #s)
		end
	end
	return s
end
function get_filename(s)
	return get_file(s):gsub(get_ext(s):gsub('%.', '%%%.'), '')
end
function milena.open_game(g)
	milena.FILE.set_dir(get_dir(g))
	game_dir = get_dir(g)
	open_msf(g)
end
milena.timer = milena.TIMER.create(500)

--   (   100  :)).
for i=1, 100, 1 do
	milena.TIMER.create(i)
end